//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1  clrCadetBlue
#property indicator_color2  clrIndianRed
#property indicator_color3  clrIndianRed
#property indicator_color4  clrIndianRed
#property indicator_color5  clrCadetBlue
#property strict

//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame        = PERIOD_CURRENT;    // Timeframe to use
extern int                HalfLength       = 25;                // Half Length Period
extern ENUM_APPLIED_PRICE Price            = PRICE_CLOSE;       // Price to use
extern double             upperDeviation   = 0.45;              // Upper envelope deviation
extern double             lowerDeviation   = 0.45;              // Lower envelope deviation
extern bool               alertsOn         = false;             // Turn alerts on
extern bool               alertsOnCurrent  = false;             // Alerts on current (still opened) bar?
extern bool               alertsMessage    = true;              // Alerts should display a pop-up message
extern bool               alertsSound      = true;              // Alerts should play an alert sound?
extern bool               alertsEmail      = false;             // Alerts should send an email?
extern bool               alertsNotify     = false;             // Alerts should send notification?
extern int                EnvelopeShift    = 0;                 // Envelope shift

//
//
//
//
//

double smBuf[];
double smBufDa[];
double smBufDb[];
double UpEnv[];
double DnEnv[];
double trend[];
string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int init()
{
   HalfLength=MathMax(HalfLength,1);
   IndicatorBuffers(6);
   SetIndexBuffer(0,smBuf);   SetIndexDrawBegin(0,HalfLength);
   SetIndexBuffer(1,smBufDa); SetIndexDrawBegin(1,HalfLength);
   SetIndexBuffer(2,smBufDb); SetIndexDrawBegin(2,HalfLength);
   SetIndexBuffer(3,UpEnv);   SetIndexDrawBegin(3,HalfLength); 
   SetIndexBuffer(4,DnEnv);   SetIndexDrawBegin(4,HalfLength);
   SetIndexBuffer(5,trend);
   
      //
      //
      //
      //
      //
   
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame == -99;
      TimeFrame         = MathMax(TimeFrame,_Period);
      
      //
      //
      //
      //
      //
     
   for (int i=0; i<7; i++) SetIndexShift(i,EnvelopeShift*TimeFrame/Period()); 
   IndicatorShortName(timeFrameToString(TimeFrame)+" Sma centered envelopes ("+(string)HalfLength+")");
   return(0);
}
int deinit() { return(0); }
  
//+------------------------------------------------------------------
//|                             
//+------------------------------------------------------------------
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,j,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit=MathMin(Bars-1,Bars-counted_bars+HalfLength);
         if (returnBars) { smBuf[0] = limit+1; return(0); }
         
   //
   //
   //
   //
   //
   
   if (TimeFrame==Period())
   {
     if (trend[limit] == -1) CleanPoint(limit,smBufDa,smBufDb);
     for (i=limit; i>=0; i--)
     {
        double sum  = iMA(NULL,0,1,0,MODE_SMA,Price,i);
        double sumw = 1;
        for(j=1; j<=HalfLength; j++)
        {
           sum  += iMA(NULL,0,1,0,MODE_SMA,Price,i+j);
           sumw += 1;
           if (j<=i)
           {
              sum  += iMA(NULL,0,1,0,MODE_SMA,Price,i-j);
              sumw += 1;
           }
        }
        smBuf[i]   = sum/sumw;
        UpEnv[i]   = (1+upperDeviation/100)*smBuf[i];
        DnEnv[i]   = (1-lowerDeviation/100)*smBuf[i];
        smBufDa[i] = EMPTY_VALUE;
        smBufDb[i] = EMPTY_VALUE;
        if (i<Bars-1)
        {
           trend[i]   = trend[i+1];
              if (smBuf[i]>smBuf[i+1]) trend[i] = 1;
              if (smBuf[i]<smBuf[i+1]) trend[i] =-1;
              if (trend[i] == -1) PlotPoint(i,smBufDa,smBufDb,smBuf);
        }
      }
     manageAlerts();    
     return(0);
     }
     
     //
     //
     //
     //
     //

     limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
     if (trend[limit]==-1) CleanPoint(limit,smBufDa,smBufDb);
     for(i=limit; i>=0; i--)
     {
        int y = iBarShift(NULL,TimeFrame,Time[i]);
           smBuf[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,HalfLength,Price,upperDeviation,lowerDeviation,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotify,0,0,y);
           smBufDa[i] = EMPTY_VALUE;
           smBufDb[i] = EMPTY_VALUE;
           UpEnv[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,HalfLength,Price,upperDeviation,lowerDeviation,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotify,0,3,y);
           DnEnv[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,HalfLength,Price,upperDeviation,lowerDeviation,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotify,0,4,y);
           trend[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,HalfLength,Price,upperDeviation,lowerDeviation,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotify,0,5,y);
           
           //
           //
           //
           //
           //
                        
     }
     for (i=limit;i>=0;i--) if (trend[i]==-1) PlotPoint(i,smBufDa,smBufDb,smBuf);      
return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i];  first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] =  from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                           second[i] = EMPTY_VALUE; }
}

//
//
//
//
//

void manageAlerts()
{
    if (alertsOn)
    {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0;          
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"sloping up");
         if (trend[whichBar] ==-1) doAlert(whichBar,"sloping down");
      }         
    }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(_Period)+" Sma centered envelopes ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Sma centered envelopes "),message);
          if (alertsNotify)  SendNotification(message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}


